package cn.estsh.i3plus.ext.mes.pcn.pojo.context;

import cn.estsh.i3plus.pojo.mes.bean.MesStation;
import io.swagger.annotations.ApiParam;
import lombok.Data;
import org.springframework.util.CollectionUtils;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import java.util.List;

/**
 * 生产过程上下文对象-站点容器条码上料明细
 */
@Data
public class MesContainerPackageDetailStationContext implements Serializable {

    private static final long serialVersionUID = -6056654777597346815L;

    @ApiParam(name = "站点信息")
    private List<MesStation> stationList;

    @ApiParam(name = "站点信息")
    private LinkedHashMap<String, List<MesContainerPackageDetailContext>> topContainerSnDetailMap2Sort;

    //从这个里面存取数据
    @ApiParam(name = "多个站点的容器条码上料明细")
    private List<MesContainerPackageDetailStationContext> stationContainerSnDetailList;

    public MesContainerPackageDetailStationContext() {}

    public MesContainerPackageDetailStationContext(List<MesStation> stationList,
                                                   LinkedHashMap<String, List<MesContainerPackageDetailContext>> topContainerSnDetailMap2Sort) {
        this.stationList = stationList;
        this.topContainerSnDetailMap2Sort = topContainerSnDetailMap2Sort;
    }

    public MesContainerPackageDetailStationContext addStationList(List<MesStation> stationList) {
        if (CollectionUtils.isEmpty(this.stationList)) this.stationList = new ArrayList<>();
        this.stationList.addAll(stationList);
        return this;
    }

    public MesContainerPackageDetailStationContext addStationContainerSnDetailList(MesContainerPackageDetailStationContext containerPackageDetailStationContext) {
        if (CollectionUtils.isEmpty(this.stationContainerSnDetailList)) this.stationContainerSnDetailList = new ArrayList<>();
        this.stationContainerSnDetailList.add(containerPackageDetailStationContext);
        return this;
    }

}
